.486
.model flat, stdcall
option casemap :none

include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\kernel32.inc
include \masm32\macros\macros.asm
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\kernel32.lib

_dwtoa proto :DWORD,:DWORD

printv MACRO varname:VARARG
    FOR arg,<varname>
        invoke StdOut,reparg(arg)
    ENDM        
ENDM

.data
    buffer db 30 dup(0)
.code
start:
    invoke _dwtoa,0,addr buffer    
    printv addr buffer,SADD(13,10)
    invoke _dwtoa,1,addr buffer    
    printv addr buffer,SADD(13,10)
    invoke _dwtoa,-1,addr buffer    
    printv addr buffer,SADD(13,10)
    invoke _dwtoa,7fffffffh,addr buffer    
    printv addr buffer,SADD(13,10)
    invoke _dwtoa,80000000h,addr buffer    
    printv addr buffer,SADD(13,10)

    invoke StdIn,addr buffer,1    
    exit
; #########################################################################
; Updated using suggestions from Donkey, twisteddweeb, and xmetal.
; This version is a attempt to minimize the size of the code at the
; expense of a slight decrease in speed relative to the original.
; #########################################################################
_dwtoa proc dwValue:DWORD, lpBuffer:DWORD

    push ebx
    push esi
    push edi
    mov eax,dwValue
    mov edi,lpBuffer

    or  eax,eax
    jnz @F
    ; Store "0" and terminator.
    mov word ptr[edi],30h
    jmp _dwtoaExit
@@:
    jns @F
    mov byte ptr[edi],'-'
    neg eax
    inc edi
@@:    
    ; Push sentinel to mark end of digits.
    push 55aa55aah
    ; Load /10 magic number (from Agner).
    mov ecx,3435973837
@@:
    ; Save value for calculating remainder.
    mov ebx,eax
    ; Divide value by 10 using magic number.
    mul ecx
    shr edx,3
    mov eax,edx
    ; Calculate remainder.
    lea edx,[edx*4+edx] ; Multiply by 8
    shl edx,1         	; Multiply by 2
    sub ebx,edx
    ; Repeat if quotient > 0
    or  eax,eax
    ; Push remainder (will be < 10).
    push ebx
    jnz @B
@@:
    ; Pop digit.
    pop edx
    ; Finished if sentinel.
    cmp edx,55aa55aah
    je  _dwtoaExit
    ; Convert to ascii.
    or  edx,30h
    ; Move to buffer. This will add 3 null bytes to the
    ; end of string that must be allowed for when the 
    ; buffer is allocated.
    mov [edi],edx    
    ; Repeat for all digits.
    inc edi
    jmp @B
_dwtoaExit:
    pop edi
    pop esi
    pop ebx
    ret
_dwtoa endp

; #########################################################################

end start
